#include <dirent.h>
#include <stdlib.h>
#include <string.h>
#include <stdio.h>
#include <sys/stat.h>
#include "h.h"

static
char rcsid[] = "$Id: h.c,v 1.9 2005/01/20 16:28:50 yuuji Exp $";

/*
 * This module should be sharpened.
 */

static
int isdir(char *path)
{
  struct stat s;
  return (0==stat(path, &s) && (s.st_mode&S_IFDIR));
}

static
int init(HM *hm)
{
  char buf[160];
  DIR *topdir, *dbdir, *entdir;
  FILE *fp;
  struct dirent *d, *dd, *ddd;
  static STR path = {0}, path2 = {0};
  struct patterns *ptns;
  struct a_pattern *aptn;
  if (NULL == hm->dir) return -1;
  if (NULL == (topdir=opendir(hm->dir))) return hm->n = -1;
  hm->n = 0; hm->ptn = 0;
  // fprintf(stderr, "opendir[%s]\n", hm->dir);
  while (NULL != (d=readdir(topdir))) {
    if (!strcmp(".", d->d_name) || !strcmp("..", d->d_name)) continue;
    if (!strop(&path, "=", hm->dir)) goto outtop;
    if (!strop(&path, "join", "/", d->d_name, NULL)) goto outtop;
    if (!isdir(path.s)) continue;
    //fprintf(stderr, "OPENDIR[%s]...\n", path.s);
    if (NULL == (dbdir=opendir(path.s))) continue;
    /* Create new */
    hm->ptn=realloc(hm->ptn, (++hm->n)*(sizeof (struct patterns*)));
    //fprintf(stderr, "hm->n[%d]...", hm->n);
    if (NULL == hm->ptn)
      goto outtop;
    if (NULL == ((hm->ptn)[hm->n-1]
                 = (struct patterns*)malloc(sizeof (struct patterns))))
      goto outtop;
    ptns = (hm->ptn)[hm->n-1];
    memset(ptns, 0, sizeof *ptns);
    if (!strop(&ptns->name, "=", d->d_name)) goto outtop;
    strop(&ptns->name, "lower");
    while (NULL != (dd=readdir(dbdir))) {
      char *fn = dd->d_name;
      static STR file = {0};
      if (!strcmp(".", fn) || !strcmp("..", fn)) continue;
      if (!strop(&path2, "=", path.s)) goto outdb;
      if (!strop(&path2, "join", "/", fn, NULL)) goto outdb;
      if (!isdir(path2.s)) continue;

      /* Read ptn */
      //fprintf(stderr, "peeking file[%s], ra=%p\n", file.s, ptns->a_ptn);
      // // // if (NULL == (fp=fopen(file.s, "r"))) continue;
      if (NULL == (entdir=opendir(path2.s))) continue;
      while (NULL != (ddd=readdir(entdir))) {
        if ('p' != ddd->d_name[0]) continue;
        if (!strop(&file, "=", path2.s)) goto outdb;
        if (!strop(&file, "join", "/", ddd->d_name, NULL)) goto outdb;

        if (NULL == (fp=fopen(file.s, "r"))) continue;
        if (NULL == (ptns->a_ptn
                     = realloc(ptns->a_ptn,
                               (++ptns->n)*sizeof (struct a_pattern*))))
          goto outdb;
        if (NULL == ((ptns->a_ptn)[ptns->n-1]
                     = (struct a_pattern*)malloc(sizeof (struct a_pattern))))
          goto outdb;
        /* fprintf(stderr, "reading file [%s]\n", file.s); */
        aptn = (ptns->a_ptn)[ptns->n-1];
        memset(aptn, 0, sizeof *aptn); /* Do not forget this */
        while (NULL != fgets(buf, sizeof buf, fp)) {
          STR *s;
          /* Alloc pattern */
          if (NULL == (aptn->pattern
                       =realloc(aptn->pattern,
                                (++aptn->n)*sizeof (STR*))))
            goto outfp;
          if (NULL == ((aptn->pattern)[aptn->n-1]
                       =(STR*)malloc(sizeof (STR))))
            goto outfp;
          s = (aptn->pattern)[aptn->n-1];
          memset(s, 0, sizeof *s);
          if (!strop(s, "=", buf)) goto outfp;
          strop(s, "chomp");
          strop(s, "lower");
#ifdef DEBUG
          fprintf(stderr, "Entry[%s][%s][%d]=[%s]\n", ptns->name.s, fn, aptn->n, (aptn->pattern[aptn->n-1])->s);
#endif
        }
        fclose(fp);
        /* Set pattern name from file name */
        strop(&aptn->pname, "=", "");
        if (!strop(&aptn->pname, "join", dd->d_name, "/", ddd->d_name, NULL))
          goto outdb;
        /* Read corresponding error message */
        strop(&aptn->errmsg, "=", "");
        if (!strop(&file, "=", path2)) goto outdb;
        if (!strop(&file, "join", "/errmsg", NULL)) goto outdb;
        strop(&aptn->errmsg, "=", ""); /* Clear default error message */
        if (NULL == (fp=fopen(file.s, "r"))) {
          continue;
        }
        while (NULL != fgets(buf, sizeof buf, fp)) {
          char *p = buf;
          while (*p && isspace(*p)) p++;
          if ('#' == *p) continue;
        if (!strop(&aptn->errmsg, "+", buf)) goto outdb;
        }
      //fprintf(stderr, "msg=%s\n", aptn->errmsg.s);
        fclose(fp);
        //  fprintf(stderr, "Total patterns for %s = %d\n", fn, aptn->n);
      }
    }
    //fprintf(stderr, "dbdir close\n");
    closedir(dbdir);
    //fprintf(stderr, "Total entries for %s = %d\n", ptns->name.s, ptns->n);
  }
  closedir(topdir);
  return 0;
  outtop:
  closedir(topdir);
  outdb:
  closedir(dbdir);
  outfp:
  fclose(fp);
  return -1;
}

/*
 * Return: 0: no match
 *         1: match
 *        -1: error
 * Using linear search, which should be replaced with more intelligent one.
 *
 * Matching pattern string is one of as follows.
 *  =STRING	Match with entire line
 *  ^STRING	Match with the beginning of line
 *  $STRING	Match with the end of line
 *  /STRING	Match with any part of line
 *  STRING	Same as /STRING
 *
 * Multiple-lines pattern will be compared respectively from left to right.
 * Comparing with the second pattern is performed against the position after
 * the end of first-line pattern matching.  Third pattern is compared with
 * sub-string after second pattern matching, and so on.
 */

int
match_internal(HM *hm, char *header, char *line, HMR *hmr)
{
  int nhm, nptns, naptn;
  struct patterns *ptns;
  struct a_pattern *aptn;
  STR *s;
  char *t;
  for (t=line+strlen(line)-1; line<t && *t && strchr("\r\n", *t); t--);
  hmr->rcode = 0;
  hmr->msg = NULL;
  for (nhm=0; nhm < hm->n; nhm++) {
    if (strcasecmp(header, hm->ptn[nhm]->name.s)) continue;
    ptns = hm->ptn[nhm];
    for (nptns=0; nptns < ptns->n; nptns++) {
      int match = 1, r, len;
      char *p = line;
      aptn = ptns->a_ptn[nptns];
      for (naptn=0; naptn < aptn->n; naptn++) {
        while (*p && isspace(*p)) p++;
        if (!*p) {
          match = 0;
          break;
        }
        s = aptn->pattern[naptn];
        len = s->len-1;
        switch (s->s[0]) {
        case '=':
          r = (!strncmp(s->s+1, p, len) && strchr("\r\n", *(p+len)));
          break;
        case '^':
          r = !strncmp(s->s+1, p, len);
          break;
        case '$':
          r = !strncmp(s->s+1, t-len+1, len);
          break;
        case '/':
          r = (strstr(p, s->s+1) ? 1 : 0);
          break;
        default:
          len = s->len;
          r = (strstr(p, s->s) ? 1 : 0);
        }
        match *= (r ? 1 : 0);
        if (match == 0) break;
        p += len;
      }
      if ((hmr->rcode=match)) {
        hmr->msg = &aptn->errmsg;
        hmr->pname = &aptn->pname;
        return 1;
      }
    }
  }
  return 0;
}

void header_match_delete(HM *hm)
{
  int nhm, nptns, naptn;
  struct patterns *ptns;
  struct a_pattern *aptn;
  STR *s;
  for (nhm=0; nhm < hm->n; nhm++) {
    ptns = hm->ptn[nhm];
    for (nptns=0; nptns < ptns->n; nptns++) {
      aptn = ptns->a_ptn[nptns];
      for (naptn=0; naptn < aptn->n; naptn++) {
        s = aptn->pattern[naptn];
        if (s) {
          strop(s, "!");          /* free STR */
          free(s);
        }
      }
      free(aptn->pattern);
      free(aptn);
    }
    free(ptns->a_ptn);
    free(ptns);
  }
  free(hm->ptn);
  hm->n = 0;
}

/*
 * Return: 0: no match
 *         1: match
 *        -1: error
 */
int
header_match(HM *hm, char *header_line, HMR *hmr)
{
  int r = 0;
  static STR header = {0};
  char *colon;
  if (0 == hm->n) {
    r=init(hm);
    if (r<0) {fputs("NF\n", stderr);return r;}
  }
  if (NULL == (colon=strchr(header_line, ':'))) return 0;
  if (!strop(&header, "n=", header_line, colon-header_line)) return -1;
  if (strchr(header.s, ' ') || strchr(header.s, '\t')) return 0;
  
  if (0 < (r=match_internal(hm, header.s, colon+1, hmr)))
    hmr->where = header.s;
  return r;
}
