#if 1
#include <stdio.h>
#endif
#include <stdlib.h>
#include <string.h>
#include <sys/param.h>
#include <sys/stat.h>
#include <arpa/nameser.h>
#include <pwd.h>
#include "antibadmail.h"
#include "s.h"

static char rcsid[] = "$Id: q.c,v 1.6 2004/07/16 13:58:20 yuuji Exp $";
static char *buf;               /* for malloc */
static char *controldir;
static STR local = {0}, path = {0};

static int localdomain;

int statdotqmail(char *home, char *ext, char dash)
{
  int baselen;
  struct stat dq;
  static STR qfile = {0}; /* shoud be static because it has mallocced area */
  if (!strop(&path, "=", home)) return -1;
  if (!strop(&path, "+", "/.qmail")) return -1;
  baselen = path.len;    /* length of "$HOME/.qmail ($HOME expanded)" */
  strop(&path, "+", ext);
  if (0 == stat(path.s, &dq))
    return 1;
  for (; path.len>=baselen; strop(&path, "chop")) {
    
    if (path.s[path.len-1] == dash) {
      if (!strop(&qfile, "=", path.s)) return -1;
      if (!strop(&qfile, "+", "default")) return -1;
      fprintf(stderr, "dq=%s\n", qfile.s);
      if (0 == stat(qfile.s, &dq))
        return 1;
    }
  }
  return 0;
}

int chkuser(char *local)
{
  char *user = NULL;
  int lenmax = strlen(local)+1;
  char *ext = local+strlen(local);
  struct passwd *pw;
  struct stat st;
  int r=-1;
  if (NULL == (user=malloc(lenmax)))
    return -1;

  do {
    strncpy(user, local, ext-local);
    user[ext-local] = '\0';
    if ((pw=getpwnam(user))) {
      if (0 > stat(pw->pw_dir, &st)) {
        continue;
      }
      fprintf(stderr, "user=[%s], ext=[%s]\n", user, ext);
      if (*ext)
        r = statdotqmail(pw->pw_dir, ext, DASH);
      else {                    /* strict match with user */
        r = 1;
      }
      if (r > 0) goto out;
    }
    for (ext--; local<ext && *ext != DASH; ext--)
      ;
  } while (local<ext);
  r = 0;                        /* not found */
 out:
  if (user) free(user);
  return r;
}
/*
 * Check if local matches with /var/qmail/users/assign.
 * THIS IS NOT HONEST CHECK!
 */
int chkassign(char *local)
{
  int r=0;
  FILE *as;
  char *colon;
  struct stat st;
  if (!strop(&path, "=", controldir)) return -1;
  if (!strop(&path, "+", "/../users/assign")) return -1;
  //if (!strop(&path, "=", "tdir/assign")) return -1;
  
  if (0 > stat(path.s, &st))
    return 0;
  if (NULL == (as=fopen(path.s, "r")))
    return 0;

  while (NULL != fgets(buf, MAXDNAME, as)) {
    if (!strchr("+=", buf[0]))
      continue;
    if (!(colon=strchr(buf, ':')))
      continue;
    *colon = '\0';
    if (!strncmp(local, buf+1, colon-buf-1)) {
      r=1;
      fprintf(stderr, "M/w [%s]\n", buf+1);
      break;
    }
  }
  fclose(as);
  return r;
}
int chkalias(char *local)
{
  int r=-1;
  static STR alias = {0};
  if (!strop(&alias, "=", "alias-")) return -1;
  if (!strop(&alias, "+", local)) return -1;
  r = chkuser(alias.s);
  strop(&alias, "!");           /* free() */
  return r;
}
int chklocal(char *local)
{
  int r=-1;
  if ((r=chkassign(local)) > 0)
    return r;
  if ((r=chkuser(local)) > 0)
    return r;
  r=chkalias(local);
  return r;
}
int islocal(char *domain)
{
  FILE *lcl;
  char *q;
  int r=0;
  if (!strop(&path, "=", controldir)) return -1;
  if (!strop(&path, "+", "/locals")) return -1;

  //fprintf(stderr, "path=%s\n", path.s);
  lcl=fopen(path.s, "r");
  strop(&path, "!");
  if (NULL == lcl)
    return -1;
  while (NULL != fgets(buf, MAXDNAME, lcl)) {
    if (buf[0] == '#')
      continue;
    q = buf+strlen(buf)-1;
    while (q>buf && strchr("\r\n ", *q))
      *q-- = '\0';
    if (!strcmp(domain, buf)) {
      r=1;
      break;
    }
  }
  fclose(lcl);
  return r;
}
int dovirtual(char *recipient)
{
  FILE *vdom;
  char *q;
  char *colon;
  int r=0;
  char *at = strchr(recipient, '@');
  char *domain;
  int llen;
  int mlen = MAXPATHLEN;
  
  if (!at) {
    if (!strop(&local, "=", recipient)) return -1;
    return 0;
  }
  llen = at-recipient;
  domain = at+1;

  if (!strop(&path, "=", controldir)) r=-1;
  else if (!strop(&path, "+", "/virtualdomains")) r=-1;
  //else if (!strop(&path, "+", "/virtualdomains.bak")) r=-1;

  vdom=fopen(path.s, "r");
  strop(&path, "!");            /* free() */
  if (r || NULL == vdom)
    return -1;
  while (NULL != fgets(buf, MAXDNAME, vdom)) {
    if (buf[0] == '#')
      continue;
    if (NULL == (colon=strchr(buf, ':')))
      continue;
    q = buf+strlen(buf);
    while (q>buf && strchr("\r\n ", *q))
      *q-- = '\0';
    if (!strncmp(domain, buf, colon-buf)) {
      /* virtualdomain found! */
      if (strlen(colon+1)+llen+1+1 > mlen)
        return -1;              /* too long */
      if (!strop(&local, "=", colon+1)) return -1;
      if (!strop(&local, "+", "-")) return -1;
      localdomain = 1;
      break;
    }
  }
  fclose(vdom);
  /* for (s=recipient; s < at && t-local < mlen; )
    *t++ = *s++;
    *t++ = '\0';*/
  strop(&local, "n+", recipient, at-recipient);
  fprintf(stderr, "vadd=[%s]\n", local.s);
  return 1;
  
}

/*
 * Return non-zero if the recipient address RECIP does not exist
 * return 1: domain part too long
 *        2: localpart too long (out of memory)
 *	 -1: other error
 */
int q_nonexistent(char *recip, char *cdir)
{
  char *at = strrchr(recip, '@');
  int llen, dlen;
  int r = -1;
  static STR domain;            /* should be static */
  localdomain = 0;
  
  if (NULL == (buf=malloc(MAXDNAME+1))) goto out;
  
  controldir = cdir;
  if (at) {                     /* user@domain */
    llen = at-recip;
    if (MAXDNAME <= (dlen = strlen(at)))
      return 1;
    if (!strop(&domain, "=", at+1)) return -1;
    if ((r=islocal(domain.s))) {
      localdomain = 1;
      if (r<0) goto out;
      strop(&local, "n=", recip, at-recip);
      //local[at-recip] = '\0';
      fprintf(stderr, "local,%s, %s\n", local.s, domain.s);
      
    } else {
      r=dovirtual(recip);
      if (r<0) return r;
    }
  } else {
    strop(&local, "=", recip);
    localdomain = 1;
  }

  fprintf(stderr, "ld=%d\n", localdomain);
  if (localdomain)
    r=chklocal(local.s);
  else
    r = -3;

 out:
  if (buf) free(buf);
  return r;
}
